#include <vcl.h>
#pragma hdrstop

#include "Unit1.h"
#include "TypeDefs.h"
#include <math.h>
#include <stdio.h>

#pragma package(smart_init)
#pragma link "cspin"
#pragma resource "*.dfm"
TForm1 *Form1;

//    a+b+c  27    a,b,c.   .

char Str[1000];
TStringList* SS;

char A[27]; // : 0-abc, 1-acb, 2-bca, 3-bac, 4-cab, 5-cba

char D[3]={1,3,9};
char SymCell[48][27], SymOr[48][6];
char* OrStr[6]={"234", "243", "342", "324", "423", "432"};
char OrPos[6][3]={{0,1,2}, {0,2,1}, {1,2,0}, {1,0,2}, {2,0,1}, {2,1,0}};
char OrMul[6][6]={{0,1,2,3,4,5}, {1,0,3,2,5,4}, {2,5,4,1,0,3}, {3,4,5,0,1,2}, {4,3,0,5,2,1}, {5,2,1,4,3,0}};

bool DifA[3][6][6]; //DifA[dir][v1][v2]   v1  v2    dir

char Sol[100][27];
int NSol;

typedef bool TA6[6];

struct TRule
{ virtual bool Check(int v)=0;
};

struct TDifR: TRule
{ virtual bool Check(int v) {return T[v][*V1];}
  TDifR* Init(int v1, int dir) {V1=&A[v1]; T=DifA[dir]; return this;}

  char* V1;
  TA6* T;
};

TDifR DifR[81];
int DifRN;

struct TMinusR: TRule
{ virtual bool Check(int v) {Res=T[v]-T[*V1]; return 1;}
  char* V1;
  char* T;
  int Res;
};

struct T4R: TRule
{ virtual bool Check(int v) {return (*M1)*(*M2)<=0;}
  int *M1, *M2;
};

struct T8R: TRule
{ virtual bool Check(int v);
  int *M1, *M2;
};

struct TLevel
{ int Lev;
  TLevel* L1;
  TRule* R[20];
  int N;

  void Init(int lev);
  void AddRule(TRule* r) {R[N++]=r;}
  void Calc();
};

TLevel L[27];

int C1,C2;

void AddSol()
{ C1++;
  char b[27];
  for(int n=0; n<48; n++)
  { char *symCell=SymCell[n], *symOr=SymOr[n];
    for(int k=0; k<27; k++) b[symCell[k]]=symOr[A[k]];
    if(memcmp(A,b,27)>0) return;
  }
  C2++;
    //  2x2x2
    //   a=2, b=3, c=4
  char p[27][6];
  for(int i=0; i<3; i++) for(int y=0; y<3; y++) for(int z=0; z<3; z++)
  { int d=D[i];
    int p0=D[(i+1)%3]*y+D[(i+2)%3]*z;
    int v0=A[p0], v2=A[p0+2*d];
    int x1=OrPos[v0][i]+2, x2=9-(OrPos[v2][i]+2);
    int c0=i*2, c1=c0+1;
    p[p0][c0]=0; p[p0][c1]=p[p0+d][c0]=x1; p[p0+d][c1]=p[p0+2*d][c0]=x2; p[p0+2*d][c1]=9;
  }
    //  
  for(int n1=0; n1<26; n1++) for(int n2=n1+1; n2<27; n2++)
  { char *p1=p[n1], *p2=p[n2];
    for(int k=0; k<3; k++)
    { char *a=p1+2*k, *b=p2+2*k;
      if(b[0]>=a[1] || a[0]>=b[1]) goto a;
    }
    return;
a:  ;
  }
  if(NSol<100) memcpy(Sol[NSol], A, 27);
  NSol++;
}

void TLevel::Init(int lev)
{ Lev=lev; L1=(lev<26)? &L[lev+1]: 0;
  int x[3]={lev%3, (lev/3)%3, lev/9};
  for(int dir=0; dir<3; dir++)
  { int c=x[dir], d=D[dir], p0=lev-d*c;
    for(int n=0; n<c; n++) AddRule(DifR[DifRN++].Init(p0+n*d, dir));
  }
}

void TLevel::Calc()
{ for(int v=0; v<6; v++)
  { A[Lev]=v;
    for(int n=0; n<N; n++) if(!R[n]->Check(v)) goto a;
    if(L1) L1->Calc();
    else AddSol();
a:  ;
  }
}

void Init()
{ for(int n=0; n<48; n++)
  { int or=n>>3;
    bool c[3]={n&1, n&2, n&4};
    for(int k=0; k<27; k++)
    { int x[3]={k%3, (k/3)%3, k/9}, x1[3];
      for(int i=0; i<3; i++)
      { x1[i]=x[OrPos[or][i]];
        if(c[i]) x1[i]=2-x1[i];
      }
      SymCell[n][k]=x1[0]+3*x1[1]+9*x1[2];
    }
    for(int k=0; k<6; k++) SymOr[n][k]=OrMul[or][k];
  }

  for(int i=0; i<3; i++) for(int v1=0; v1<6; v1++) for(int v2=0; v2<6; v2++)
    DifA[i][v1][v2]= OrPos[v1][i]!=OrPos[v2][i];

  for(int n=0; n<27; n++) L[n].Init(n);
}

void TForm1::Calc()
{ Init();
  L[1].Calc();

  SS->Clear();

  sprintf(Str, " %d", NSol);
  SS->Add(Str);

  char* p=Str;
  p+=sprintf(p, "         : ");
  for(int n=0; n<6; n++)
  { if(n) p+=sprintf(p, " ");
    p+=sprintf(p, "%s", OrStr[n]);
  }
  p+=sprintf(p, ".");
  SS->Add(Str);

  int nSol=min(NSol,100);
  for(int n=0; n<nSol; n++)
  { char* sol=Sol[n];
    p=Str;
    p+=sprintf(p, "%d. ", n+1);

    int c[6];  memset(c,0, sizeof(c));
    for(int n=0; n<27; n++) c[sol[n]]++;
    for(int n=0; n<6; n++) p+=sprintf(p, "%d", c[n]);
    p+=sprintf(p, " ");

    for(int z=0; z<3; z++)
    { if(z) p+=sprintf(p, " ");
      p+=sprintf(p, "(");
      for(int y=0; y<3; y++)
      { p+=sprintf(p, "(");
        for(int x=0; x<3; x++)
        { if(x) p+=sprintf(p, " ");
          p+=sprintf(p, "%s", OrStr[sol[x+3*y+9*z]]);
        }
        p+=sprintf(p, ")");
      }
      p+=sprintf(p, ")");
    }
    SS->Add(Str);
  }
  E->Text=SS->Text;
}

__fastcall TForm1::TForm1(TComponent* Owner)
  : TForm(Owner)
{ SS=new TStringList;
  Calc();
}

void __fastcall TForm1::FormDestroy(TObject *Sender)
{ delete SS;}